package org.zeroturnaround.javarebel.integration.log4j.cbp;

import org.zeroturnaround.bundled.javassist.CannotCompileException;
import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * 
 * @author Richard Julien
 * @version 1.0
 */
public class CategoryCBP extends JavassistClassBytecodeProcessor {

  /** Logger type enumeration. */
  private String[] typeLevels = { "info", "debug", "warn", "error", "fatal" };

  public void process(ClassPool classPool, ClassLoader classLoader, CtClass ctClass) throws Exception {
    for (int i = 0; i < typeLevels.length; i++) {
      addListenMethod(typeLevels[i], ctClass);
    }
  }

  /**
   * Add listen reload method.
   * 
   * @param method
   *          the method to listen
   * @param ctClass
   *          the class to map
   * @throws NotFoundException
   * @throws CannotCompileException
   */
  private void addListenMethod(String method, CtClass ctClass) throws NotFoundException, CannotCompileException {
    CtMethod m = ctClass.getMethod(method, "(Ljava/lang/Object;)V");
    //LoggerFactory.getInstance().echo("[JRebel-Log4j]  **** Listen Method : " + m);
    m.insertBefore("if(org.zeroturnaround.javarebel.integration.log4j.Log4jReloader.mustReload()) {"
        + "org.apache.log4j.LogManager.resetConfiguration();" + "}");
  }
}
